package org.jeecg.modules.stm.wb.survey.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.wb.survey.entity.WbSurveyReport;
import org.jeecg.modules.stm.wb.survey.service.IWbSurveyReportService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 调查报告
 * @Author: jeecg-boot
 * @Date:   2024-03-14
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/wb.survey/wbSurveyReport")
@Slf4j
public class WbSurveyReportController extends JeecgController<WbSurveyReport, IWbSurveyReportService> {
	@Autowired
	private IWbSurveyReportService wbSurveyReportService;
	
	/**
	 * 分页列表查询
	 *
	 * @param wbSurveyReport
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "调查报告-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<WbSurveyReport>> queryPageList(WbSurveyReport wbSurveyReport,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<WbSurveyReport> queryWrapper = QueryGenerator.initQueryWrapper(wbSurveyReport, req.getParameterMap());
		Page<WbSurveyReport> page = new Page<WbSurveyReport>(pageNo, pageSize);
		IPage<WbSurveyReport> pageList = wbSurveyReportService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param wbSurveyReport
	 * @return
	 */
	@AutoLog(value = "调查报告-添加")
	  
	@RequiresPermissions("wb.survey:wb_survey_report:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody WbSurveyReport wbSurveyReport) {
		wbSurveyReportService.save(wbSurveyReport);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param wbSurveyReport
	 * @return
	 */
	@AutoLog(value = "调查报告-编辑")
	  
	@RequiresPermissions("wb.survey:wb_survey_report:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody WbSurveyReport wbSurveyReport) {
		wbSurveyReportService.updateById(wbSurveyReport);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "调查报告-通过id删除")
	  
	@RequiresPermissions("wb.survey:wb_survey_report:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		wbSurveyReportService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "调查报告-批量删除")
	  
	@RequiresPermissions("wb.survey:wb_survey_report:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.wbSurveyReportService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "调查报告-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<WbSurveyReport> queryById(@RequestParam(name="id",required=true) String id) {
		WbSurveyReport wbSurveyReport = wbSurveyReportService.getById(id);
		if(wbSurveyReport==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(wbSurveyReport);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param wbSurveyReport
    */
    @RequiresPermissions("wb.survey:wb_survey_report:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, WbSurveyReport wbSurveyReport) {
        return super.exportXls(request, wbSurveyReport, WbSurveyReport.class, "调查报告");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("wb.survey:wb_survey_report:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, WbSurveyReport.class);
    }

}
